include "Vram.inc"
include "VVram.inc"

ext @Temp@Byte
ext @Temp@Byte2
ext @Temp@Word
ext @Temp@Word2
ext @Temp@Word3
ext @Temp@Byte3

Top equ Vram

ext VVramFront_, RowFlags_
ext Chars_

pVram equ @Temp@Word
pVVram equ @Temp@Word2
pFlags equ @Temp@Word3
yCount equ @Temp@Byte3
flagBit equ @Temp@Byte2


VVramToVramRow:
    ldab #VVramWidth
    do
        ldx <pVVram 
        ldaa 0,x
        inx
        stx <pVVram 

        ldx <pVram  
        staa 0,x
        inx
        stx <pVram  

        decb
    while ne | wend
    ldaa <pVram+1 | adda #VramWidth-VVramWidth | staa <pVram+1
    ldaa <pVram | adca #0 | staa <pVram
rts


; void VVramToVramAll();
cseg
VVramToVramAll_:　public	VVramToVramAll_
    psha | pshb
        ldx #Top
        stx <pVram  
        ldx #VVramFront_
        stx <pVVram 
        ldaa #VVramHeight
        staa <yCount
        do
            bsr VVramToVramRow
            dec yCount
        while ne | wend
    pulb | pula
rts

; void VVramToVramChanged();
cseg
VVramToVramChanged_: public VVramToVramChanged_
    psha | pshb
        ldx #Top
        stx <pVram  
        ldx #VVramFront_
        stx <pVVram 
        ldx #RowFlags_
        ldab 0,x
        inx
        stx <pFlags 
        ldaa #1
        staa <flagBit 
        ldaa #VVramHeight
        staa <yCount
        do
            bitb <flagBit
            if ne
                pshb
                    bsr VVramToVramRow
                pulb
            else
                ldaa <pVram+1 | adda #VramWidth | staa <pVram+1
                ldaa <pVram | adca #0 | staa <pVram

                ldaa <pVVram+1 | adda #VVramWidth | staa <pVVram+1
                ldaa <pVVram | adca #0 | staa <pVVram
            endif
            asl flagBit 
            if eq
                ldx <pFlags 
                ldab 0,x
                inx
                stx <pFlags 
                ldaa #1
                staa <flagBit 
            endif
            dec yCount
        while ne | wend
        clr RowFlags_
        clr RowFlags_+1
        clr RowFlags_+2
    pulb | pula
rts


; void SetPattern(byte c, byte pattern, byte count);
pSource equ @Temp@Word
pDestination equ @Temp@Word2
dseg
SetPattern_@Param1: public SetPattern_@Param1
    defb 0
SetPattern_@Param2: public SetPattern_@Param2
    defb 0
cseg
SetPattern_: public SetPattern_
    psha | pshb
        suba #$80
        staa <pDestination+1 | clr <pDestination
        asl <pDestination+1 | rol <pDestination ;*2
        asl <pDestination+1 | rol <pDestination ;*4
        asl <pDestination+1 | rol <pDestination ;*8
        ldaa <pDestination+1 
        adda #low CharGen
        staa <pDestination+1
        ldaa <pDestination
        adca #high CharGen
        staa <pDestination

        ldaa SetPattern_@Param1
        staa <pSource+1 | clr <pSource
        asl <pSource+1 | rol <pSource ;*2
        asl <pSource+1 | rol <pSource ;*4
        asl <pSource+1 | rol <pSource ;*8
        ldaa <pSource+1 
        adda #low Chars_
        staa <pSource+1
        ldaa <pSource
        adca #high Chars_
        staa <pSource

        ldab SetPattern_@Param2
        aslb ;*2
        aslb ;*4
        aslb ;*8
        do
            ldx <pSource
            ldaa 0,x
            inx
            stx <pSource

            ldx <pDestination
            staa 0,x
            inx
            stx <pDestination

            decb
        while ne | wend
    pulb | pula
rts
